/* --------------------------------------------------------------  */
/* (C)Copyright 2001,2007,                                         */
/* International Business Machines Corporation,                    */
/* Sony Computer Entertainment, Incorporated,                      */
/* Toshiba Corporation,                                            */
/*                                                                 */
/* All Rights Reserved.                                            */
/* --------------------------------------------------------------  */
/* PROLOG END TAG zYx                                              */
#ifndef _PROFILE_H_
#define _PROFILE_H_ 1

/* The following macros, prof_cp0 thru prof_cp31, provide performance
 * check pointing support on the standalone SPU simulator (spusim) and
 * the system simulator (systemsim). Everytime one of the macros is executed, 
 * performance information
 * is printed to the simulator's output stream. Performance metrics are
 * only available by executing the SPU in pipeline mode.
 *
 * Several checkpoints have special meaning. They include:
 *
 * prof_cp0  - clear current performance counters
 * prof_cp30 - start recording performnace information (default)
 * prof_cp31 - stop recording performance information
 */

#ifndef __xlc__
/* dummy instructions for profiling */

#define prof_cp0() __asm__ volatile("and $0,$0,$0\n\tlnop");
#define prof_cp1() __asm__ volatile("and $1,$1,$1\n\tlnop");
#define prof_cp2() __asm__ volatile("and $2,$2,$2\n\tlnop");
#define prof_cp3() __asm__ volatile("and $3,$3,$3\n\tlnop");
#define prof_cp4() __asm__ volatile("and $4,$4,$4\n\tlnop");
#define prof_cp5() __asm__ volatile("and $5,$5,$5\n\tlnop");
#define prof_cp6() __asm__ volatile("and $6,$6,$6\n\tlnop");
#define prof_cp7() __asm__ volatile("and $7,$7,$7\n\tlnop");
#define prof_cp8() __asm__ volatile("and $8,$8,$8\n\tlnop");
#define prof_cp9() __asm__ volatile("and $9,$9,$9\n\tlnop");
#define prof_cp10() __asm__ volatile("and $10,$10,$10\n\tlnop");
#define prof_cp11() __asm__ volatile("and $11,$11,$11\n\tlnop");
#define prof_cp12() __asm__ volatile("and $12,$12,$12\n\tlnop");
#define prof_cp13() __asm__ volatile("and $13,$13,$13\n\tlnop");
#define prof_cp14() __asm__ volatile("and $14,$14,$14\n\tlnop");
#define prof_cp15() __asm__ volatile("and $15,$15,$15\n\tlnop");
#define prof_cp16() __asm__ volatile("and $16,$16,$16\n\tlnop");
#define prof_cp17() __asm__ volatile("and $17,$17,$17\n\tlnop");
#define prof_cp18() __asm__ volatile("and $18,$18,$18\n\tlnop");
#define prof_cp19() __asm__ volatile("and $19,$19,$19\n\tlnop");
#define prof_cp20() __asm__ volatile("and $20,$20,$20\n\tlnop");
#define prof_cp21() __asm__ volatile("and $21,$21,$21\n\tlnop");
#define prof_cp22() __asm__ volatile("and $22,$22,$22\n\tlnop");
#define prof_cp23() __asm__ volatile("and $23,$23,$23\n\tlnop");
#define prof_cp24() __asm__ volatile("and $24,$24,$24\n\tlnop");
#define prof_cp25() __asm__ volatile("and $25,$25,$25\n\tlnop");
#define prof_cp26() __asm__ volatile("and $26,$26,$26\n\tlnop");
#define prof_cp27() __asm__ volatile("and $27,$27,$27\n\tlnop");
#define prof_cp28() __asm__ volatile("and $28,$28,$28\n\tlnop");
#define prof_cp29() __asm__ volatile("and $29,$29,$29\n\tlnop");
#define prof_cp30() __asm__ volatile("and $30,$30,$30\n\tlnop");
#define prof_cp31() __asm__ volatile("and $31,$31,$31\n\tlnop");

#else /* XLC */

/* dummy instructions for profiling */
#pragma mc_func prof_cp0  { "18200000" } /* and 0,0,0 */
#pragma mc_func prof_cp1  { "18204081" } /* and 1,1,1 */
#pragma mc_func prof_cp2  { "18208102" } /* and 2,2,2 */
#pragma mc_func prof_cp3  { "1820c183" } /* and 3,3,3 */
#pragma mc_func prof_cp4  { "18210204" } /* and 4,4,4 */
#pragma mc_func prof_cp5  { "18214285" } /* and 5,5,5 */
#pragma mc_func prof_cp6  { "18218306" } /* and 6,6,6 */
#pragma mc_func prof_cp7  { "1821c387" } /* and 7,7,7 */
#pragma mc_func prof_cp8  { "18220408" } /* and 8,8,8 */
#pragma mc_func prof_cp9  { "18224489" } /* and 9,9,9 */
#pragma mc_func prof_cp10 { "1822850a" } /* and 10,10,10 */
#pragma mc_func prof_cp11 { "1822c58b" } /* and 11,11,11 */
#pragma mc_func prof_cp12 { "1823060c" } /* and 12,12,12 */
#pragma mc_func prof_cp13 { "1823468d" } /* and 13,13,13 */
#pragma mc_func prof_cp14 { "1823870e" } /* and 14,14,14 */
#pragma mc_func prof_cp15 { "1823c78f" } /* and 15,15,15 */
#pragma mc_func prof_cp16 { "18240810" } /* and 16,16,16 */
#pragma mc_func prof_cp17 { "18244891" } /* and 17,17,17 */
#pragma mc_func prof_cp18 { "18248912" } /* and 18,18,18 */
#pragma mc_func prof_cp19 { "1824c993" } /* and 19,19,19 */
#pragma mc_func prof_cp20 { "18250a14" } /* and 20,20,20 */
#pragma mc_func prof_cp21 { "18254a95" } /* and 21,21,21 */
#pragma mc_func prof_cp22 { "18258b16" } /* and 22,22,22 */
#pragma mc_func prof_cp23 { "1825cb97" } /* and 23,23,23 */
#pragma mc_func prof_cp24 { "18260c18" } /* and 24,24,24 */
#pragma mc_func prof_cp25 { "18264c99" } /* and 25,25,25 */
#pragma mc_func prof_cp26 { "18268d1a" } /* and 26,26,26 */
#pragma mc_func prof_cp27 { "1826cd9b" } /* and 27,27,27 */
#pragma mc_func prof_cp28 { "18270e1c" } /* and 28,28,28 */
#pragma mc_func prof_cp29 { "18274e9d" } /* and 29,29,29 */
#pragma mc_func prof_cp30 { "18278f1e" } /* and 30,30,30 */
#pragma mc_func prof_cp31 { "1827cf9f" } /* and 31,31,31 */

#endif /* __xlc__ */

#define prof_clear()	prof_cp0()
#define prof_start()	prof_cp30()
#define prof_stop()	prof_cp31()

#endif /* _PROFILE_H_ */
