/* -------------------------------------------------------
 *
 * Licensed Materials - Property of IBM.
 * (C) Copyright IBM Corporation 2001, 2007
 * All Rights Reserved.
 *
 * US Government Users Restricted Rights -
 * Use, duplication or disclosure restricted by
 * GSA ADP Schedule Contract with IBM Corporation.
 *
 * Filename : define64bit.h
 *
 * Purpose  : Figure out if the host is 32-bit or 64-bit
 *
 * ------------------------------------------------------- */

#ifndef _DEFINE64BIT_H_
#define _DEFINE64BIT_H_

/*
 * The build environment passed -DHOST_64=1 if we're building a
 * 64 bit binary.
 *
 * We define __64BITS__ because some code we dont' control
 * expects it.
 */

#if defined(HOST_64) && !defined(_AIX)
#define __64BIT__
#endif /* #if defined(HOST_64) && !defined(_AIX) */

#endif /* #ifndef _DEFINE64BIT_H_ */
