/* -------------------------------------------------------
 *
 * Licensed Materials - Property of IBM.
 * (C) Copyright IBM Corporation 2001, 2006
 * All Rights Reserved.
 *
 * US Government Users Restricted Rights -
 * Use, duplication or disclosure restricted by
 * GSA ADP Schedule Contract with IBM Corporation.
 *
 * Filename : atomic.h
 *
 * Purpose  : Isolate Linux/AIX atomic_t and atomic_read
 *
 * ------------------------------------------------------- */
/* we depend upon "mambo.h" being the first file included in every *.c file;
 * check that it has been included */
#if !defined(_MAMBO_H_) && defined(MAMBO)
#error "common/mambo.h" not included first
#endif /* #if !defined(_MAMBO_H_) && defined(MAMBO) */

#ifndef _ATOMIC_H_
#define _ATOMIC_H_

#ifndef _AIX

#define ATOMIC_READ(x)  (x)
#define ATOMIC_ADD(a,b) (b)+=(a)
#define ATOMIC_SUB(a,b) (b)-=(a)

#else /* #ifndef _AIX */

#ifdef _AIX
#include <sys/atomic_op.h>                        /* fetch_and_add */
#else /* #ifdef _AIX */
/* The system header file was giving us too many
 * warnings about pragmas so we just include what
 * we want below */
typedef int *atomic_p;
extern int fetch_and_add (atomic_p, int);
#endif /* #ifdef _AIX */

#define ATOMIC_READ(x)  (x)
#define ATOMIC_ADD(a,b) fetch_and_add(CAST(int *,&(b)), a);
#define ATOMIC_SUB(a,b) fetch_and_add(CAST(int *,&(b)), -a);

#endif /* #ifndef _AIX */

#endif /* #ifndef _ATOMIC_H_ */
