/* -------------------------------------------------------
 *
 * Licensed Materials - Property of IBM.
 * (C) Copyright IBM Corporation 2001, 2006
 * All Rights Reserved.
 *
 * US Government Users Restricted Rights -
 * Use, duplication or disclosure restricted by
 * GSA ADP Schedule Contract with IBM Corporation.
 *
 * Filename : ed.h
 *
 * Purpose  : Emitter Data Routines
 *
 * ------------------------------------------------------- */

#ifndef _ED_H_
#define _ED_H_


#ifndef MSR_PR_BIT
#define MSR_PR_BIT 0x4000Ull
#endif /* #ifndef MSR_PR_BIT */
#ifndef MSR_SF_BIT
#define MSR_SF_BIT 0x8000000000000000ULL
#endif /* #ifndef MSR_SF_BIT */
#ifndef MSR_HV_BIT
#define MSR_HV_BIT 0x1000000000000000ULL
#endif /* #ifndef MSR_HV_BIT */

#include <stdio.h>                                /* FILE struct */

#include "emitter/emitter_data.h"
#include "emitter/atomic.h"

extern int ed_compare (EMIT_DATA *edata1, EMIT_DATA *edata2);
extern int ed_print_good (FILE *out, EMIT_DATA *edata);
#define ed_print(edata) ed_print_good(stdout,edata)

#endif /* #ifndef _ED_H_ */
