/* -------------------------------------------------------
 *
 * Licensed Materials - Property of IBM.
 * (C) Copyright IBM Corporation 2003, 2006
 * All Rights Reserved.
 *
 * US Government Users Restricted Rights -
 * Use, duplication or disclosure restricted by
 * GSA ADP Schedule Contract with IBM Corporation.
 *
 * Filename : emit_collector.h
 *
 * Purpose  : All the common header files an emitter collecter needs
 *
 * ------------------------------------------------------- */

#ifndef _EMIT_COLLECTOR_H_
#define _EMIT_COLLECTOR_H_


#include <stdio.h>
#include <stdlib.h>
#include <sys/types.h>

#ifdef __CYGWIN32__
#include <cygwin/shm.h>
#else /* #ifdef __CYGWIN32__ */
#include <sys/shm.h>
#endif /* #ifdef __CYGWIN32__ */

#include <unistd.h>
#include <signal.h>
#include <time.h>


#include "emitter/ed.h"                           /* ed_print_good */
#include "it_codes.h"                             /* IT_LOAD, etc. */


#ifndef ASSERT
#include <assert.h>
#define ASSERT(c) assert(c)
#endif /* #ifndef ASSERT */


/* for the emitter collectors -- we use a consistent format for
   all VA, EA and PA -- always 64-bits. */
#ifdef FormatVA
#undef FormatVA
#define FormatVA Format64
#endif /* #ifdef FormatVA */
#ifdef FormatEA
#undef FormatEA
#define FormatEA Format64
#endif /* #ifdef FormatEA */


#endif /* #ifndef _EMIT_COLLECTOR_H_ */
