/* -------------------------------------------------------
 *
 * Licensed Materials - Property of IBM.
 * (C) Copyright IBM Corporation 2001, 2007
 * All Rights Reserved.
 *
 * US Government Users Restricted Rights -
 * Use, duplication or disclosure restricted by
 * GSA ADP Schedule Contract with IBM Corporation.
 *
 * Filename : sti_emitter_union_t.h
 *
 * Purpose :
 *
 * List of STI emitter data elements.  This gets included
 * in main union data structure in emitter_data.h
 *
 * ------------------------------------------------------- */
/* we depend upon "mambo.h" being the first file included in every *.c file;
 * check that it has been included */
#if !defined(_MAMBO_H_) && defined(MAMBO)
#error "common/mambo.h" not included first
#endif /* #if !defined(_MAMBO_H_) && defined(MAMBO) */

#ifndef _STI_EMITTER_UNION_T_H_
#define _STI_EMITTER_UNION_T_H_

/* These fields are included into an EMIT_DATA structure.
   We must have these types defined (by "sti_emitter_data.h")
   before we include this file. */



APU_INST_INFO apu_inst;
APU_PIPE_INST_INFO apu_pipe_inst;
APU_MEM_INFO apu_mem;
MFC_DMA_INFO mfc_dma;
APU_TASK_INFO apu_task_info;
APU_WAIT_INFO apu_wait_info;

APU_STATS_ANNOTATION_INFO   apu_annotation;
APU_OP_INFO apu_op;

APU_PIPE_TRANS_INFO pipe_trans;
APU_PERF_STATS_INFO perf_stats;
APU_PIPE_PERF_STATS_INFO pipe_stats;

APU_DMA_TG_STATUS_RQ_INFO apu_dma_tg_status_rq;
APU_DMA_TG_COMPLETE_INFO apu_dma_tg_complete;
APU_DMA_TG_STATUS_QRY_INFO apu_dma_tg_status_qry;

PPU_DMA_TG_STATUS_RQ_INFO ppu_dma_tg_status_rq;
PPU_DMA_TG_COMPLETE_INFO ppu_dma_tg_complete;
PPU_DMA_TG_INTR_INFO ppu_dma_tg_intr;
PPU_DMA_TG_STATUS_QRY_INFO ppu_dma_tg_status_qry;

SPU_LOAD_STORE_INFO spu_load_store;


#endif /* #ifndef _STI_EMITTER_UNION_T_H_ */
