/* -------------------------------------------------------
 *
 * Licensed Materials - Property of IBM.
 * (C) Copyright IBM Corporation 2001, 2006
 * All Rights Reserved.
 *
 * US Government Users Restricted Rights -
 * Use, duplication or disclosure restricted by
 * GSA ADP Schedule Contract with IBM Corporation.
 *
 * Filename : environment.h
 *
 * Purpose  : Any "pre-mambo.h" setup for includes
 *
 * ------------------------------------------------------- */

/* On AIX, with xlC, if you include math.h under an
   extern C, you get two different copies of the math
   routines.  This seems to be because it "knows" that
   we are compiling with C++ and wants to define multiple
   methods (for float, for double, ...), and that's fine
   in C++, but C thinks they are the same.  To avoid this,
   we include math.h at the very beginning, outside the
   extern C block, and hope that we will not include it
   twice. */
#if defined(__xlC__)
#define _LARGE_FILES 1

/* include math.h now, before we start anything else */
#include <math.h>
#endif /* #if defined(__xlC__) */

