#------------------------------------------------------------------------
#
#   IBM Software
#   Licensed Material - Property of IBM
#   (C) Copyright International Business Machines Corp. 2003
#   All Rights Reserved.
#
#   U.S. Government Users Restricted Rights - Use, duplication or
#   disclosure restricted by GSA ADP Schedule Contract with
#   IBM Corp.
#
#------------------------------------------------------------------------
#  BE_buttons.tcl
#
#  This file will add machine specific buttons to the GUI.
#------------------------------------------------------------------------

proc Machine_Button_Defs { button_table } {

    # Add the performance models dialog button
    set spumodes [ button $button_table.spumodes -text "SPU Modes" -command {Machine_Button_Defs_SPUModes $Controls::currentSim} -state "normal" ]

    # Add the SPU Visualization button
    # If BLT is not found, disable the button.
    set state [ expr { [ catch { package require BLT } ] ? "disabled" : "normal" } ]
    set pvis [ button $button_table.spuvis -text "SPE Visualization" -command {Machine_Button_Defs_SPUVis $Controls::currentSim} -state $state ]

    table $button_table $spumodes [Controls::Find_Table_Hole $button_table] -cspan 1 -fill x
    table $button_table $pvis [Controls::Find_Table_Hole $button_table] -cspan 1 -fill x
    Controls::NewSimBasedButton $spumodes
    Controls::NewSimBasedButton $pvis
}

# This is the hook to call when the SPU Modes button is pressed.
proc Machine_Button_Defs_SPUModes {sim} {
    SPUModes::Create $sim
}

# This is the hook to call when the SPU Vis button is pressed.
proc Machine_Button_Defs_SPUVis {sim} {
    PVIZ::Display $sim
}

proc Machine_Refresh { sim } {
    SPUModes::Refresh $sim
}
