#####################################################
#
#   Error dialog -- put up a top-level window
#                   that displays so error text,
#                   wait for the user to press "OK"
#
#####################################################

proc ErrorDialog {text w} {

    busy hold .
    if {$w != "."} {
	busy hold $w
    }
    update
    toplevel .err
    frame .err.inner
    label .err.inner.text -text $text -bg white -fg black
    button .err.inner.ok -text " OK " -command "ErrorDialogCallback $w"
    table .err.inner \
	    0,0 .err.inner.text  -padx {30 30} -pady {30 30} \
	    1,0 .err.inner.ok    -anchor w -padx {30 30} -pady {0 20}
    .err configure -bg red
    .err.inner configure -bg white
    table .err \
	    0,0 .err.inner -padx {10 10} -pady {10 10}

    bind .err <Key-Return> "ErrorDialogCallback $w"
}


proc ErrorDialogCallback {w} {
    busy release .
    busy forget .
    if {$w != "."} {
	busy release $w
	busy forget $w
    }
    destroy .err
    update
}
