#------------------------------------------------------------------------
#
#   IBM Software
#   Licensed Material - Property of IBM
#   (C) Copyright International Business Machines Corp. 2003,2004
#   All Rights Reserved.
#
#   U.S. Government Users Restricted Rights - Use, duplication or
#   disclosure restricted by GSA ADP Schedule Contract with
#   IBM Corp.
#
#------------------------------------------------------------------------
#  ppc4xx_xlate.tcl
#
#------------------------------------------------------------------------

namespace eval TLB_Frame {
    variable tlb_win_state   
}

proc TLB_Frame::Create { win which_tlb cpucmd } {

    set TLB_Frame::tlb_win_state($win,which_tlb) $which_tlb
    set TLB_Frame::tlb_win_state($win,cpucmd) $cpucmd

    checkbutton $win.validchk -text "Valid Only" -anchor w -variable TLB_Frame::tlb_win_state($win,tlbvalid) -command "TLB_Frame::Refresh $win"
    #label $TLBs.datahdr -relief groove -textvariable TLBHeader($root) -font textbox_font
    text $win.datahdr -relief groove -font textbox_font -height 1 -wrap none -width 70
    text $win.data -wrap none -width 70 -height 5 -yscrollcommand "$win.data_sy set" -font textbox_font
    scrollbar $win.data_sy -orient vert -command "$win.data yview"

    table $win \
        $win.label      0,0 -cspan 5 -fill x \
        $win.validchk   0,3 -cspan 1 -fill x \
        $win.datahdr    1,0 -cspan 5 -fill x -anchor w\
        $win.data       2,0 -cspan 4 -fill both \
        $win.data_sy    2,4 -cspan 1 -fill y

	table configure $win c* r* -resize none
	table configure $win r2 c0 -resize both
}
proc TLB_Frame::Refresh { win } {

    variable tlb_win_state

    set cpucmd $tlb_win_state($win,cpucmd)
    if { $tlb_win_state($win,tlbvalid) } { set amount "valid"} else { set amount "all" }

    set cpucmd $tlb_win_state($win,cpucmd)

	set tlbs [$cpucmd display $tlb_win_state($win,which_tlb) $amount]
    set tlbs [split $tlbs "\n"]

    $win.datahdr configure -state normal
    $win.datahdr delete 1.0 end
    $win.datahdr insert end [lindex $tlbs 0]
    $win.datahdr configure -state disabled
    $win.data delete 1.0 end
    foreach tlb [lrange $tlbs 1 end-1]  {
        $win.data insert end "$tlb\n"
    }
    $win.data delete insert-1c end        ;# delete last newline char
}

namespace eval Embedded_xlate {
}

# ------------------------------------------------------------------
# Embedded_xlate::Init -- Initalize the status window
# ------------------------------------------------------------------
proc Embedded_xlate::Init {root _upstate args} {

    variable mystate 
    upvar $_upstate  initstate 
    TclUtils::copyarray initstate mystate $root       ;# create mystate($idx,x)

	set sim $mystate($root,sim)

    label $root.xlateLabel -text "Address Translation"

    ;#####  TLBs   ####################################################################
    frame $root.itlbs -relief sunken -bd 2
    label $root.itlbs.label -text "iTLBs"
    TLB_Frame::Create $root.itlbs itlb $mystate($root,cpucmd)

    frame $root.dtlbs -relief sunken -bd 2
    label $root.dtlbs.label -text "dTLBs"
    TLB_Frame::Create $root.dtlbs dtlb $mystate($root,cpucmd)

    frame $root.utlbs -relief sunken -bd 2
    label $root.utlbs.label -text "uTLBs"
    TLB_Frame::Create $root.utlbs utlb $mystate($root,cpucmd)

    button $root.close -text "Close" -command "destroy $root"

	table $root \
		$root.xlateLabel   0,0 -cspan 4 -fill x \
		$root.itlbs        1,0 -cspan 4 -fill both \
		$root.dtlbs        2,0 -cspan 4 -fill both \
		$root.utlbs        3,0 -cspan 4 -fill both \
		$root.close        4,3 -fill x

	table configure $root c* r* -resize none
	table configure $root r1 r2 r3 c0 -resize both

    set title [treesim::get_path_name $mystate($root,widget) $mystate($root,treeidx) 1 ] 
	wm title $root "$title: Address translation"

	Embedded_xlate::Refresh $root 1
	return "Embedded_xlate::Refresh"
}

# ------------------------------------------------------------------
# Embedded_xlate::Refresh -- Refresh the contents of the status window
# ------------------------------------------------------------------
proc Embedded_xlate::Refresh { root force args } {
    TLB_Frame::Refresh $root.itlbs
    TLB_Frame::Refresh $root.dtlbs
    TLB_Frame::Refresh $root.utlbs
}
