#------------------------------------------------------------------------
#
#   IBM Software
#   Licensed Material - Property of IBM
#   (C) Copyright International Business Machines Corp. 2004,2005
#   All Rights Reserved.
#
#   U.S. Government Users Restricted Rights - Use, duplication or
#   disclosure restricted by GSA ADP Schedule Contract with
#   IBM Corp.
#
#------------------------------------------------------------------------
#  menubar.tcl
#
#
#------------------------------------------------------------------------
namespace eval Menubar {
}

#---------------------------------------------------------
# Menubar::Show_About
#     Show the about message
#---------------------------------------------------------
proc Menubar::Show_About {} {
    tk_messageBox -type ok -message [version list] 
}

#---------------------------------------------------------
# Menubar::Init
#     Initalize the menubar
#---------------------------------------------------------
proc Menubar::Init {} {

    # create menubar widget
    menu .menubar
    # attach it to the main window
    . config -menu .menubar

    # Create File menu
    set m [menu .menubar.file -tearoff 0 ]
    .menubar add cascade -label File -menu $m
    $m add command -label Quit -command quit  

    # Create Window menu
    set m [menu .menubar.window -tearoff 0 ]
    .menubar add cascade -label Window -menu $m 
    # add cascaded commands later to make startup quick
    $m configure -postcommand "Window::init_menu $m"

    # Create Help menu
    set m [menu .menubar.help -tearoff 0 ]
    .menubar add cascade -label Help -menu $m
    $m add command -label About -command Menubar::Show_About
}

#---------------------------------------------------------
# Menubar::Refresh
#     Refresh the contents of the menubar
#---------------------------------------------------------
proc Menubar::Refresh { } {
}
