#------------------------------------------------------------------------
#
#	IBM Software
#	Licensed Material - Property of	IBM
#	(C) Copyright International Business Machines Corp. 2004
#	All Rights Reserved.
#
#	U.S. Government	Users Restricted Rights - Use, duplication or
#	disclosure restricted by GSA ADP Schedule Contract with
#   IBM Corp.
#
#------------------------------------------------------------------------
#  pipeline.tcl
#
#------------------------------------------------------------------------

#------------------------------------------------------------------------
#
# Pipeline_Init -- Initalize the pipeline window
#
#------------------------------------------------------------------------
proc Pipeline_Init {root _upstate args} {
    global Pipeline

    upvar $_upstate  initstate 
    TclUtils::copyarray initstate Pipeline $root      ;# create Pipeline($root,x)
    set sim $Pipeline($root,sim)
    set mcmcmd  $Pipeline($root,mcmcmd)

    text $root.pipelinenames -width 110 -height 20 
    button $root.refresh -command "Pipeline_Refresh $root" -text "Refresh"

    $root.pipelinenames insert end "[$mcmcmd pipeline display]"

    table $root \
        $root.pipelinenames    0,0 \
        $root.refresh       2,0 -cspan 2 -fill x

    table configure $root c* r* -resize none

    set title [treesim::get_path_name $Pipeline($root,widget) $Pipeline($root,treeidx) 1 ] 
    wm title $root "$title: Pipeline" 

    return "Pipeline_Refresh"
}

######################################################################
#
# Pipeline_Refresh -- Refresh the contents of the pipeline window
#
######################################################################
proc Pipeline_Refresh { root args } {
    global Pipeline

    set sim $Pipeline($root,sim)
    set mcmcmd  $Pipeline($root,mcmcmd)
    # this is a hack for lack of time: will revisit this 
    $root.pipelinenames delete 1.0 18.0
    $root.pipelinenames insert 1.0 "[$mcmcmd pipeline display]"
}
