#------------------------------------------------------------------------
#
#   IBM Software
#   Licensed Material - Property of IBM
#   (C) Copyright International Business Machines Corp. 2003,2004
#   All Rights Reserved.
#
#   U.S. Government Users Restricted Rights - Use, duplication or
#   disclosure restricted by GSA ADP Schedule Contract with
#   IBM Corp.
#
#------------------------------------------------------------------------
#  ppc4xx_xlate.tcl
#
#------------------------------------------------------------------------
namespace eval PPC4xx_xlate {
}

# ------------------------------------------------------------------
# PPC4xx_xlate::Init -- Initalize the status window
# ------------------------------------------------------------------
proc PPC4xx_xlate::Init {root _upstate args} {

    variable mystate 
    upvar $_upstate  initstate 
    TclUtils::copyarray initstate mystate $root       ;# create mystate($idx,x)

	set sim $mystate($root,sim)

    label $root.xlateLabel -text "Address Translation"

    ;#####  TLBs   ####################################################################
    set TLBs $root.tlbs
    frame $TLBs -relief sunken -bd 2
    label $TLBs.label -text "TLBs"
    checkbutton $TLBs.validchk -text "Valid Only" -anchor w -variable PPC4xx_xlate::mystate($root,tlbvalid) -command "PPC4xx_xlate::Refresh $root 1"
    #label $TLBs.datahdr -relief groove -textvariable TLBHeader($root) -font textbox_font
    text $TLBs.datahdr -relief groove -font textbox_font -height 1 -wrap none -width 70
    text $TLBs.data -wrap none -width 70 -height 5 -yscrollcommand "$TLBs.data_sy set" -font textbox_font
    scrollbar $TLBs.data_sy -orient vert -command "$TLBs.data yview"

    table $TLBs \
        $TLBs.label      0,0 -cspan 5 -fill x \
        $TLBs.validchk   0,3 -cspan 1 -fill x \
        $TLBs.datahdr    1,0 -cspan 5 -fill x -anchor w\
        $TLBs.data       2,0 -cspan 4 -fill both \
        $TLBs.data_sy    2,4 -cspan 1 -fill y

    table configure $TLBs c* r* -resize none
    table configure $TLBs r2 c0  -resize both

    button $root.close -text "Close" -command "destroy $root"

	table $root \
		$root.xlateLabel   0,0 -cspan 4 -fill x \
		$TLBs              1,0 -cspan 4 -fill both \
		$root.close        2,3 -fill x

	table configure $root c* r* -resize none
	table configure $root r1 c0 -resize both

    set title [treesim::get_path_name $mystate($root,widget) $mystate($root,treeidx) 1 ] 
	wm title $root "$title: Address translation"

	PPC4xx_xlate::Refresh $root 1
	return "PPC4xx_xlate::Refresh"
}

# ------------------------------------------------------------------
# PPC4xx_xlate::Refresh -- Refresh the contents of the status window
# ------------------------------------------------------------------
proc PPC4xx_xlate::Refresh { root force args } {
    variable mystate

	set cpucmd $mystate($root,cpucmd)

    set TLBs $root.tlbs
    if { $mystate($root,tlbvalid) } { set amount "valid"} else { set amount "all" }
	set tlbs [$cpucmd display tlb $amount]
    set tlbs [split $tlbs "\n"]

    #set TLBHeader($root) [lindex $tlbs 0]
    $TLBs.datahdr configure -state normal
    $TLBs.datahdr delete 1.0 end
    $TLBs.datahdr insert end [lindex $tlbs 0]
    $TLBs.datahdr configure -state disabled
    $TLBs.data delete 1.0 end
    foreach tlb [lrange $tlbs 1 end-1]  {
        $TLBs.data insert end "$tlb\n"
    }
    $TLBs.data delete insert-1c end        ;# delete last newline char
}
