#------------------------------------------------------------------------
#
#   IBM Software
#   Licensed Material - Property of IBM
#   (C) Copyright International Business Machines Corp. 2003
#   All Rights Reserved.
#
#   U.S. Government Users Restricted Rights - Use, duplication or
#   disclosure restricted by GSA ADP Schedule Contract with
#   IBM Corp.
#
#------------------------------------------------------------------------
#  tcl_utils.tcl
#
#  Generally useful tcl routines
#------------------------------------------------------------------------

proc ListPushUnique {listname item} {
    global $listname
    if { [info exists $listname] == 1 } {
        eval "set thelist $$listname"
        if { [lsearch -exact $thelist $item] == -1 } {
            lappend $listname $item
        }
    } else {
        lappend $listname $item
    }
}

proc memsize_toint { memsize } {
    array set suffix_val {K 1024 M 1024*1024 G 1024*1024*1024}
    set retval 0
    if {[regexp {((0x)?\d+)([kKmMgG]?)} $memsize match digits hex suffix]} {
        if {[string length $suffix] == 0} {
            set retval $digits
        } else {
            set retval [mul64 $digits [expr $suffix_val([string toupper $suffix])]]
        }
    }
    return $retval
}
