#------------------------------------------------------------------------
#
#   IBM Software
#   Licensed Material - Property of IBM
#   (C) Copyright International Business Machines Corp. 2004
#   All Rights Reserved.
#
#   U.S. Government Users Restricted Rights - Use, duplication or
#   disclosure restricted by GSA ADP Schedule Contract with
#   IBM Corp.
#
#------------------------------------------------------------------------
#  .systemsim.tcl
#
#  This is the default toplevel script that is run when using the CLI.
#------------------------------------------------------------------------

set IMAGES "../../../images"

# Initialize the systemsim tcl environment
source $env(LIB_DIR)/cell/mambo_init.tcl

# Configure and create the simulated machine
define dup cell myconf

# Uncomment to change the memory size. Default size is 128M.
#myconf config memory_size 128M

myconf config UART/0/enabled off

# Call the config_hook proc if it is defined to modify the config
if {[string length [info procs config_hook]] > 0} {
    config_hook myconf
}

define machine myconf mysim

# Uncomment this to enable automatic starting of the default emitter readers
#EmitterReaders::init_default mysim linux_boot

# Start the GUI if -g option was given
MamboInit::gui $env(LIB_DIR)/cell/gui/gui.tcl





