#------------------------------------------------------------------------
#
#   IBM Software
#   Licensed Material - Property of IBM
#   (C) Copyright International Business Machines Corp. 2004
#   All Rights Reserved.
#
#   U.S. Government Users Restricted Rights - Use, duplication or
#   disclosure restricted by GSA ADP Schedule Contract with
#   IBM Corp.
#
#------------------------------------------------------------------------
#  daxpy.tcl
#
#  This script will run the sample daxpy program in standalone mode.
#------------------------------------------------------------------------

# Start the simulator using the standard initialization script.
source .systemsim.tcl

# Set real mode boundary register
mysim mfc 0 set rm_boundary 1

# Make the SPU cycle accurate
mysim spu 0 set model pipeline

# Set a trigger to stop the simulator with the SPU program finishes
proc spu_stop { args } {
    simstop
}
mysim trigger set assoc SPU_STOP spu_stop

# Load the SPU program directly onto SPU 0
mysim spu 0 load daxpy

# Turn on any available performance models
turn_perf_models_on

# Run the program
mysim go

# Now print the detailed SPU statistics
puts [mysim spu 0 display statistics]

# Test is complete. Exit the simulator.
quit
