#!/bin/sh

# To put the tools in a directory other than /opt/ppc32-tools, set PREFIX=<dir> before invoking this script
PREFIX=${PREFIX:-/opt/ppc32-tools}
# To obtain the tar files from a local directory other than $PREFIX/tars, set TARS=<dir> before invoking this script
TARS=${TARS:-$PREFIX/tars}
# Either put the gdb patch in the current directory or set $PATCHDIR to the directory containing the patch before invoking this script
PATCHDIR=${PATCHDIR:-$(pwd)}
# To build for a different target, set TARGET=<foo> before invoking this script
TARGET=${TARGET:-powerpc-ibm-eabi}
# To build a version other than 6.3, set GDB_VERSION=x.y before invoking this script
GDB_VERSION=${GDB_VERSION:-6.3}

BUILD=$PREFIX/build
GNU_MIRROR=ftp://ftp.ibiblio.org/pub/mirrors/gnu/ftp/gnu/

# Tools versions
GDB_SRC=gdb-$GDB_VERSION

# Set up
mkdir -p $TARS $BUILD

# Obtain packages
if [ ! -e $TARS/$GDB_SRC.tar.bz2 ]; then
    cd $TARS && wget $GNU_MIRROR/gdb/$GDB_SRC.tar.bz2
fi

# Build and install gdb
cd $BUILD
rm -rf $GDB_SRC
tar -xjvf $TARS/$GDB_SRC.tar.bz2
cd $GDB_SRC
patch -p1 < $PATCHDIR/systemsim_$GDB_SRC.diff
./configure --prefix=$PREFIX --target=$TARGET --disable-nls --disable-tui --disable-gdbtk --disable-profiling --disable-sim
make
make install

