#------------------------------------------------------------------------
#
#   IBM Software
#   Licensed Material - Property of IBM
#   (C) Copyright International Business Machines Corp. 2004
#   All Rights Reserved.
#
#   U.S. Government Users Restricted Rights - Use, duplication or
#   disclosure restricted by GSA ADP Schedule Contract with
#   IBM Corp.
#
#------------------------------------------------------------------------
#  systemsim.gdb
#
#  gdb setup to debug applications running on Systemsim.
#------------------------------------------------------------------------

define systemsim-debug
  set architecture powerpc:a35
  target remote $arg0
end
document systemsim-debug
Attach to Systemsim simulator to debug a program.
Specify communication method via socket ([host]:<port>) or TTY.
end

define systemsim-off
  set architecture powerpc:common
end

define systemsim-cycles
  monitor puts [mysim display cycles]
end
document systemsim-cycles
Displays number of "cycles" on the systemsim console
end

define systemsim-tlb
  monitor puts [mysim cpu $arg0 display tlb $arg1]
end
document systemsim-tlb
Display TLB information on the systemsim console
  Usage: systemsim-tlb <cpu> <#|valid|all>
end

define systemsim-slb
  monitor puts [mysim cpu $arg0 display slb $arg1]
end
document systemsim-slb
Display SLB information on the systemsim console
  Usage: systemsim-slb <cpu> <#|valid|all>
end
